﻿using UniversityContracts.BindingModels;
using UniversityContracts.ViewModels;
using UniversityDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace UniversityDatabaseImplement.Models
{
    public class Student : IStudentModel
    {
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }
        [Required]
        public string RecordCardNumber { get; set; }
        [ForeignKey("StudentId")]
        public virtual List<StatementStudent> StatementStudents { get; set; } = new();
        [ForeignKey("StudentId")]
        public virtual List<StudentExaminationResult> StudentExaminationResults { get; set; } = new();
        public static Student Create(StudentBindingModel model)
        {
            return new Student
            {
                Id = model.Id,
                Name = model.Name,
                RecordCardNumber = model.RecordCardNumber
            };
        }
        public void Update(StudentBindingModel model)
        {
            if (model == null) return;

            Id = model.Id;
            Name = model.Name;
            RecordCardNumber = model.RecordCardNumber;
        }

        public StudentViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name,
            RecordCardNumber = RecordCardNumber
        };
    }
}
